diff -r -c bash-1_14_7/execute_cmd.c bash1147/execute_cmd.c
*** bash-1_14_7/execute_cmd.c	Wed Mar 10 09:43:46 1999
--- bash1147/execute_cmd.c	Fri Mar 19 17:49:29 1999
***************
*** 2421,2427 ****
--- 3101,3111 ----
  	   if the first line (or up to 30 characters) are in the ASCII set.
  	   Execute the contents as shell commands. */
  	int larray = array_len (args) + 1;
+ #if defined (USE_VMS)
+ 	int i, should_exec = 1;
+ #else
  	int i, should_exec = 0;
+ #endif
  
  	{
  	  int fd = open (command, O_RDONLY);
***************
*** 2443,2450 ****
--- 3127,3139 ----
  		 characters. */
  
  	      if (sample_len > 0 && sample[0] == '#' && sample[1] == '!')
+ #if defined (USE_VMS)
+ 		return (execute_shell_script
+ 			(sample, sample_len, words, command, args, env));
+ #else
  		return (execute_shell_script
  			(sample, sample_len, command, args, env));
+ #endif
  	      else if ((sample_len != -1) &&
  		       check_binary_file (sample, sample_len))
  		{
***************
*** 2453,2458 ****
--- 3142,3149 ----
  		}
  	    }
  	}
+ 
+ #if !(defined (USE_VMS))
  #if defined (JOB_CONTROL)
  	/* Forget about the way that job control was working. We are
  	   in a subshell. */
***************
*** 2467,2478 ****
--- 3158,3179 ----
  	set_sigchld_handler ();
  #endif /* JOB_CONTROL */
  	set_sigint_handler ();
+ #endif
  
  	/* Insert the name of this shell into the argument list. */
+ #if defined (USE_VMS)
+ 	newargs = (char **)xmalloc ((1 + larray) * sizeof (char *));
+ 
+ 	for (i = larray - 1; i; i--)
+ 	  newargs[i] = args[i - 1];
+ 
+ 	args = newargs;
+ #else
  	args = (char **)xrealloc ((char *)args, (1 + larray) * sizeof (char *));
  
  	for (i = larray - 1; i; i--)
  	  args[i] = args[i - 1];
+ #endif
  
  	args[0] = shell_name;
  	args[1] = command;
***************
*** 2490,2504 ****
--- 3191,3242 ----
  	    execve (shell_name, args, env);
  	    __setostype (1);	/* Turn the POSIX semantics back on. */
  #else
+ #if defined (USE_VMS)
+ 	    if (flag)
+ 	      {
+ #if defined (USE_VMS)
+ #if 0
+ 		{
+ 		  char buffer[256];
+ 		  fprintf (stderr, "stdin: %s\n", getname (0, buffer));
+ 		  fprintf (stderr, "stdout: %s\n", getname (1, buffer));
+ 		  fprintf (stderr, "stderr: %s\n", getname (2, buffer));
+ 		}
+ #endif
+ 		if ((real_pid = vfork ()) < 0)
+ 		  return (real_pid);
+ 		else if (real_pid == 0)
+ 		  {
+ 		    if ((status = execve (shell_name, args, env)) >= 0)
+ 		      exit (status);
+ 		  }
+ 		else
+ 		  {
+ 		    waitpid (real_pid, &status, 0);
+ 		    return (status);
+ 		  }
+ #endif
+ 	      }
+ 	    else
+ #endif
  	    execve (shell_name, args, env);
  #endif /* isc386 && _POSIX_SOURCE */
  
+ #if 0 /* defined (USE_VMS) */
+ 	    /* ??? Copy stuff from Gnu make to execute command file */
+ #endif
+ 
  	    /* Oh, no!  We couldn't even exec this! */
  	    if ((stat (args[0], &finfo) == 0) && (S_ISDIR (finfo.st_mode)))
  	      report_error ("%s: is a directory", args[0]);
  	    else
  	      file_error (args[0]);
  
+ #if defined (USE_VMS)
+ 	    free (newargs);
+ 	    if (flag == 2)
+ 	      return -1;
+ #endif
  	    return (EXECUTION_FAILURE);
  	  }
  	else
***************
*** 2551,2556 ****
--- 3289,3298 ----
  			pipe_in, strerror (errno));
        if (pipe_in > 0)
          close (pipe_in);
+ #if defined (USE_VMS)
+       /* reset file pointer */
+       lseek (0, 0, SEEK_SET);
+ #endif
      }
    if (pipe_out != NO_PIPE)
      {
***************
*** 2831,2836 ****
--- 3573,3581 ----
  	  struct stat finfo;
  	  int stat_result;
  
+ #if defined (USE_VMS)
+ 	  redirectee_word = vmsutil_expand_path (redirectee_word);
+ #endif
  	  stat_result = stat (redirectee_word, &finfo);
  
  	  if ((stat_result == 0) && (S_ISREG (finfo.st_mode)))
***************
*** 2844,2850 ****
--- 3589,3600 ----
  	  if (stat_result != 0)
  	    redirect->flags |= O_EXCL;
  
+ #if defined (USE_VMS)
+ 	  fd = open (redirectee_word, redirect->flags | O_APPEND, 0666,
+ 		     "rfm=stmlf", "ctx=rec", "rat=none", "shr=del,get,put,upd");
+ #else
  	  fd = open (redirectee_word, redirect->flags, 0666);
+ #endif
  
  	  if ((fd < 0) && (errno == EEXIST))
  	    {
***************
*** 2854,2860 ****
  	}
        else
  	{
! 	  fd = open (redirectee_word, redirect->flags, 0666);
  #if defined (AFS_CREATE_BUG)
  	  if ((fd < 0) && (errno == EACCES))
  	    fd = open (redirectee_word, (redirect->flags & ~O_CREAT), 0666);
--- 3604,3618 ----
  	}
        else
  	{
! #if defined (USE_VMS)
! 	  redirectee_word = vmsutil_expand_path (redirectee_word);
! #endif
! #if defined (USE_VMS)
! 	  fd = open (redirectee_word, redirect->flags, 0666,
! 		     "rfm=stmlf", "ctx=rec", "rat=none", "shr=del,get,put,upd");
! #else
! 	  fd = open (redirectee_word, redirect->flags, 0666); 
! #endif
  #if defined (AFS_CREATE_BUG)
  	  if ((fd < 0) && (errno == EACCES))
  	    fd = open (redirectee_word, (redirect->flags & ~O_CREAT), 0666);
***************
*** 2869,2875 ****
--- 3627,3637 ----
  	{
  	  if (remembering)
  	    /* Only setup to undo it if the thing to undo is active. */
+ #if defined (USE_VMS)
+ 	    if ((fd != redirector) && (vmsfcntl (redirector, F_GETFD, 0) != -1))
+ #else
  	    if ((fd != redirector) && (fcntl (redirector, F_GETFD, 0) != -1))
+ #endif
  	      add_undo_redirect (redirector);
  	    else
  	      add_undo_close_redirect (redirector);
***************
*** 2934,2944 ****
--- 3696,3725 ----
  	 the new input.  Place it in a temporary file. */
        if (redirectee)
  	{
+ #if defined (USE_VMS)
+ 	  char *filename;
+ 	  char *tname;
+ 	  char *tmpdir;
+ #else
  	  char filename[40];
+ #endif
  	  pid_t pid = getpid ();
  
  	  /* Make the filename for the temp file. */
+ #if defined (USE_VMS)
+ 	  tmpdir = getenv ("TMPDIR");
+ 	  if (tmpdir == NULL)
+ 	    tmpdir = "/tmp";
+ 
+ 	  tname = xmalloc (strlen (tmpdir) + sizeof ("/shXXXXXX"));
+ 	  sprintf (tname, "%s/sh%6.6d", tmpdir, pid % 1000000);
+ 	  tname = vmsutil_expand_path (tname);
+ 	  filename = alloca (strlen (tname) + 1);
+ 	  strcpy (filename, tname);
+ 	  free (tname);
+ #else
  	  sprintf (filename, "/tmp/t%d-sh", pid);
+ #endif
  
  	  fd = open (filename, O_TRUNC | O_WRONLY | O_CREAT, 0666);
  	  if (fd < 0)
***************
*** 3014,3029 ****
--- 3795,3824 ----
  	    }	  
  
  	  close (fd);
+ #if 0 /* ??? defined (USE_VMS) */
+ 	  if (errno && errno != ENOTTY)
+ 	    return (errno);
+ 	  else
+ 	    errno = 0;
+ #else
  	  if (errno)
  	    return (errno);
+ #endif
  
  	  /* Make the document really temporary.  Also make it the input. */
  	  fd = open (filename, O_RDONLY, 0666);
  
+ #if defined (USE_VMS) /* otherwise file is unlinked */
+ 	  if (fd < 0)
+ #else
  	  if (unlink (filename) < 0 || fd < 0)
+ #endif
  	    {
  	      if (fd >= 0)
  	        close (fd);
+ #if defined (USE_VMS)
+ 	      remove (filename);
+ #endif
  	      return (errno);
  	    }
  
***************
*** 3031,3037 ****
--- 3826,3836 ----
  	    {
  	      if (remembering)
  		/* Only setup to undo it if the thing to undo is active. */
+ #if defined (USE_VMS)
+ 		if ((fd != redirector) && (vmsfcntl (redirector, F_GETFD, 0) != -1))
+ #else
  		if ((fd != redirector) && (fcntl (redirector, F_GETFD, 0) != -1))
+ #endif
  		  add_undo_redirect (redirector);
  		else
  		  add_undo_close_redirect (redirector);
***************
*** 3042,3047 ****
--- 3841,3849 ----
  	      if (dup2 (fd, redirector) < 0)
  		{
  		  close (fd);
+ #if defined (USE_VMS)
+ 		  remove (filename);
+ #endif
  		  return (errno);
  		}
  
***************
*** 3058,3063 ****
--- 3860,3871 ----
  #else
  	  close (fd);
  #endif
+ #if defined (USE_VMS)
+ #if 0
+ 	  if (remove (filename) != 0)
+ #endif
+ 	    add_delay_remove (filename);
+ #endif
  	}
        break;
  
***************
*** 3067,3073 ****
--- 3875,3885 ----
  	{
  	  if (remembering)
  	    /* Only setup to undo it if the thing to undo is active. */
+ #if defined (USE_VMS)
+ 	    if (vmsfcntl (redirector, F_GETFD, 0) != -1)
+ #else
  	    if (fcntl (redirector, F_GETFD, 0) != -1)
+ #endif
  	      add_undo_redirect (redirector);
  	    else
  	      add_undo_close_redirect (redirector);
***************
*** 3091,3097 ****
--- 3903,3913 ----
  	     unless closed by something like `exec 2<&-'. */
  	  /* if ((already_set || set_unconditionally) && (ok_to_set))
  		set_it () */
+ #if defined (USE_VMS)
+ 	  if (((vmsfcntl (redir_fd, F_GETFD, 0) == 1) || set_clexec) &&
+ #else
  	  if (((fcntl (redir_fd, F_GETFD, 0) == 1) || set_clexec) &&
+ #endif
  	       (redirector > 2))
  	    SET_CLOSE_ON_EXEC (redirector);
  	}
***************
*** 3100,3106 ****
--- 3916,3927 ----
      case r_close_this:
        if (for_real)
  	{
+ 	  char buffer[256];
+ #if defined (USE_VMS)
+ 	  if (remembering && (vmsfcntl (redirector, F_GETFD, 0) != -1))
+ #else
  	  if (remembering && (fcntl (redirector, F_GETFD, 0) != -1))
+ #endif
  	    add_undo_redirect (redirector);
  
  #if defined (BUFFERED_INPUT)
***************
*** 3129,3135 ****
--- 3950,3960 ----
    int new_fd, clexec_flag;
    REDIRECT *new_redirect, *closer;
  
+ #if defined (USE_VMS)
+   new_fd = dup (fd);
+ #else
    new_fd = fcntl (fd, F_DUPFD, SHELL_FD_BASE);
+ #endif
  
    if (new_fd < 0)
      {
***************
*** 3139,3146 ****
--- 3964,3976 ----
    else
      {
        REDIRECT *dummy_redirect;
+       char buffer[256];
  
+ #if defined (USE_VMS)
+       clexec_flag = vmsfcntl (fd, F_GETFD, 0);
+ #else
        clexec_flag = fcntl (fd, F_GETFD, 0);
+ #endif
  
        rd.dest = 0L;
        closer = make_redirection (new_fd, r_close_this, rd);
***************
*** 3228,3237 ****
--- 4058,4095 ----
  {
    struct stat finfo;
    static int user_id = -1;
+ #if defined (USE_VMS)
+   char *ext, *newname;
+   int len;
+ #endif
  
    /* Determine whether this file exists or not. */
+ #if defined (USE_VMS)
+   len = strlen (name);
+   if (len + 5 > PATH_MAX)
+     return 0;
+ 
+   newname = xmalloc (len + 5);
+   strcpy (newname, name);
+   
+   ext = newname + len;
+ 
+   /* skip a directory */
+   while (stat (newname, &finfo) < 0 || S_ISDIR (finfo.st_mode))
+     {
+ #if defined (USE_VMS)
+       if (!vmsutil_add_executable_suffix (newname, ext))
+ #endif
+ 	{
+ 	  free (newname);
+ 	  return 0; /* failure */
+ 	}
+     }
+   free (newname);
+ #else
    if (stat (name, &finfo) < 0)
      return (0);
+ #endif
  
    /* If the file is a directory, then it is not "executable" in the
       sense of the shell. */
***************
*** 3478,3484 ****
--- 4336,4347 ----
    int path_len;
  
    path_len = strlen (path);
+ #if defined (USE_VMS)
+   /* for adding extention (dot + 3ext) */
+   full_path = xmalloc (2 + path_len + name_len + 1 + 3);
+ #else
    full_path = xmalloc (2 + path_len + name_len);
+ #endif
    strcpy (full_path, path);
    full_path[path_len] = '/';
    strcpy (full_path + path_len + 1, name);
***************
*** 3520,3526 ****
--- 4383,4394 ----
  
    if (absolute_program (name))
      {
+ #if defined (USE_VMS)
+       /* for adding extention (dot + 3ext) */
+       full_path = xmalloc (1 + name_len + 1 + 3);
+ #else
        full_path = xmalloc (1 + name_len);
+ #endif
        strcpy (full_path, name);
  
        status = file_status (full_path);
***************
*** 3661,3666 ****
--- 4529,4537 ----
        value = xmalloc (1 + i - start);
        strncpy (value, string + start, i - start);
        value [i - start] = '\0';
+ #if defined (USE_VMS)
+       value = vmsutil_expand_path (value);
+ #endif
  
        return (value);
      }
***************
*** 3696,3698 ****
--- 4567,4724 ----
      }
    return (0);
  }
+ 
+ #if defined (USE_VMS)
+ static int
+ check_batch_file (char *filename)
+ {
+   int len;
+ 
+   if ((len = strlen (filename)) > 4)
+     if ((filename[len - 4] == '.')
+ 	&& (filename[len - 3] == 'C' || filename[len - 3] == 'c')
+ 	&& (filename[len - 2] == 'O' || filename[len - 2] == 'o')
+ 	&& (filename[len - 1] == 'M' || filename[len - 1] == 'm'))
+       return 1;
+ 
+   return 0;
+ }
+ 
+ static void
+ expand_words_for_internal_command (WORD_LIST *words)
+ {
+   char *p;
+ 
+   if (!vmsutil_path_expand || words == NULL)
+     return;
+ 
+   words = words->next; /* skip command name */
+   while (words)
+     {
+       p = words->word->word;
+       if (words->word->expansion)
+ 	{
+ 	  /* nothing */
+ 	}
+       words->word->word = p;
+       words = words->next;
+     }
+ }
+ 
+ static void
+ expand_arguments_for_external_command (WORD_LIST *words, char **args, char **except)
+ {
+   char *p, *sysroot = NULL;
+   int i, sysroot_len = -1;
+ 
+   if (!vmsutil_path_expand || words == NULL || args == NULL || *args == NULL)
+     return;
+ 
+   if (vmsutil_sysroot_len > 0)
+     {
+       sysroot = get_string_value ("SYSROOT");
+       sysroot_len = strlen (sysroot);
+     }
+ 
+   args++; /* skip command name */
+   words = words->next;
+   while ((p = *args) != NULL)
+     {
+       /* may skip argument */
+       if (except != NULL)
+ 	{
+ 	  if (strnicmp (p, "--", sizeof ("--") - 1) == 0)
+ 	    {
+ 	      except = NULL; /* terminate switch */
+ 	      args++;
+ 	      goto done;
+ 	    }
+ 
+ 	  for (i = 1; except[i] != NULL; i++)
+ 	    {
+ 	      if (strnicmp (p, except[i], strlen (except[i])) == 0)
+ 		{
+ 		skip_args:
+ 		  args++;
+ 		  if (*args != NULL) /* skip only complete argument */
+ 		    {
+ 		      words = words->next;
+ 		      args++;
+ 		    }
+ 		  goto done;
+ 		}
+ 	    }
+ 	}
+ 
+       /* expands only non-quoted string */
+       if (words->word->expansion)
+ 	{
+ 	  /* insterts SYSROOT(may have double-slashed drive name) */
+ 	  if (sysroot_len > 0 && p[0] == '/'
+ 	      && (p[1] == '\0' || (p[1] != '/' && p[2] != '\0')))
+ 	    {
+ 	      p = xrealloc (p, strlen (p) + sysroot_len + 1);
+ 	      memmove (p + sysroot_len, p, strlen (p) + 1);
+ 	      memcpy (p, sysroot, sysroot_len);
+ 	    }
+ 
+ 	  /* expands double-slashed drive name */
+ 	  if (p[0] == '/' && p[1] == '/' && isalpha(p[2])
+ 	      && (p[3] == '/' || p[3] == '\0'))
+ 	    {
+ 	      p[0] = p[2];
+ 	      p[1] = ':';
+ 	      strcpy (p + 2, p + 3);
+ 	      p = xrealloc (p, strlen(p) + 1);
+ 	    }
+ 	}
+ 
+       /* stores and increses */
+       *args++ = p;
+     done:
+       words = words->next;
+     }
+ }
+ 
+ static void
+ maybe_expand_arguments (WORD_LIST *words, char *command, char **args)
+ {
+   static char *except_sed[] = { "sed", "-e", NULL };
+   static char *except_gsed[] = { "gsed", "-e", NULL };
+   static char **except_array[] =
+     {
+       except_sed,
+       except_gsed,
+       NULL
+     };
+   static char *shells[] = { "bash", "sh", NULL };
+   char **except = NULL, *fixp, *p;
+   int i, need_expand = 1;
+ 
+   if (!vmsutil_path_expand || words == NULL || command == NULL
+       || args == NULL || *args == NULL)
+     return;
+ 
+   fixp = savestring (command);
+   vmsutil_toslash (fixp);
+   if ((p = strrchr (fixp, '/')) == NULL)
+     p = fixp - 1;
+   p++;
+   for (i = 0; shells[i] != NULL; i++)
+     if (strnicmp (p, shells[i], strlen (shells[i])) == 0)
+       {
+ 	need_expand = 0;
+ 	break;
+       }
+   if (need_expand)
+     {
+       for (i = 0; except_array[i] != NULL; i++)
+ 	if (strnicmp (p, except_array[i][0], strlen (except_array[i][0])) == 0)
+ 	  except = except_array[i];
+     }
+   free (fixp);
+ 
+   if (need_expand)
+     expand_arguments_for_external_command (words, args, except);
+ }
+ #endif
diff -r -c bash-1_14_7/execute_cmd.h bash1147/execute_cmd.h
*** bash-1_14_7/execute_cmd.h	Wed Mar 10 09:43:46 1999
--- bash1147/execute_cmd.h	Wed Mar 10 09:44:54 1999
***************
*** 44,47 ****
--- 44,53 ----
  extern void close_all_files __P((void));
  #endif
  
+ #if defined (USE_VMS)
+ extern int shell_execve_dos (WORD_LIST *words, char *command, char **args,
+ 			     char **env, int flag);
+ extern char *extract_unit (char *string, int *p_index, int separator);
+ #endif
+ 
  #endif /* _EXECUTE_CMD_H_ */
diff -r -c bash-1_14_7/filecntl.h bash1147/filecntl.h
*** bash-1_14_7/filecntl.h	Wed Mar 10 09:43:46 1999
--- bash1147/filecntl.h	Wed Mar 10 09:44:54 1999
***************
*** 30,36 ****
--- 30,61 ----
  
  #define FD_NCLOEXEC    0
  
+ #if defined (USE_VMS)
+ #define F_DUPFD 0
+ #define F_GETFD 1
+ #define F_SETFD 2
+ #define F_GETFL 3
+ #define F_SETFL 4
+ #define F_GETLK 7
+ #define F_SETLK 8
+ #define F_SETLKW 9
+ #define SET_CLOSE_ON_EXEC(fd)                  \
+   do {                                         \
+ 	fcntl ((fd), F_SETFD, FD_CLOEXEC);     \
+ 	vmsfcntl ((fd), F_SETFD, FD_CLOEXEC);  \
+   } while (0)
+ #define SET_OPEN_ON_EXEC(fd)                   \
+   do {                                         \
+ 	fcntl ((fd), F_SETFD, FD_NCLOEXEC);    \
+ 	vmsfcntl ((fd), F_SETFD, FD_NCLOEXEC); \
+   } while (0)
+ #else
  #define SET_CLOSE_ON_EXEC(fd)  (fcntl ((fd), F_SETFD, FD_CLOEXEC))
  #define SET_OPEN_ON_EXEC(fd)   (fcntl ((fd), F_SETFD, FD_NCLOEXEC))
+ #endif
+ 
+ #if 0 /* VMS */
+ #define O_TEXT 0
+ #endif
  
  #endif /* ! _FILECNTL_H_ */
diff -r -c bash-1_14_7/general.c bash1147/general.c
*** bash-1_14_7/general.c	Wed Mar 10 09:43:47 1999
--- bash1147/general.c	Fri Mar 19 17:49:15 1999
***************
*** 24,30 ****
--- 24,32 ----
  #include <ctype.h>
  #include <errno.h>
  #include "bashtypes.h"
+ #if !defined (VMS)
  #include <sys/param.h>
+ #endif
  #if defined (_POSIX_VERSION)
  #  if defined (amiga) && defined (USGr4)
  #    define _POSIX_SOURCE
***************
*** 45,50 ****
--- 47,55 ----
  
  #include <sys/times.h>
  #include "maxpath.h"
+ #if defined (USE_VMS)
+ #include "vmsutil.h"
+ #endif
  
  #if !defined (errno)
  extern int errno;
***************
*** 318,324 ****
--- 323,333 ----
  {
    int flags, set = 0;
  
+ #if defined (USE_VMS)
+   if ((flags = vmsfcntl (fd, F_GETFL, 0)) < 0)
+ #else
    if ((flags = fcntl (fd, F_GETFL, 0)) < 0)
+ #endif
      return;
  
  #if defined (O_NONBLOCK)
***************
*** 338,344 ****
--- 347,357 ----
  #endif /* O_NDELAY */
  
    if (set)
+ #if defined (USE_VMS)
+     vmsfcntl (fd, F_SETFL, flags);
+ #else
      fcntl (fd, F_SETFL, flags);
+ #endif
  }
  
  
***************
*** 658,664 ****
  	      i = (start < 0) ? 0 : start;
  	      continue;
  	    }
! 	}
      }
  
    if (!*result)
--- 671,677 ----
  	      i = (start < 0) ? 0 : start;
  	      continue;
  	    }
!  	}
      }
  
    if (!*result)
***************
*** 666,671 ****
--- 679,685 ----
        *result = stub_char;
        result[1] = '\0';
      }
+ 
    return (result);
  }
  
***************
*** 680,686 ****
--- 694,705 ----
    char *result;
    int result_len;
    
+ #if defined (USE_VMS) /* ??? handled concealed logical names
+ 			   e.g. /disk$axpvmssys -> /disk$axpvmssys/000000 */
    if (!dot_path || *string == '/')
+ #else
+   if (!dot_path || *string == '/')
+ #endif
      result = savestring (string);
    else
      {
***************
*** 716,722 ****
--- 735,746 ----
    if (!string || !*string)
      return (0);
  
+ #if defined (USE_VMS) /* ??? handled concealed logical names
+ 			   e.g. /disk$axpvmssys -> /disk$axpvmssys/000000 */
    if (*string == '/')
+ #else
+   if (*string == '/')
+ #endif
      return (1);
  
    if (*string++ == '.')
***************
*** 773,779 ****
--- 797,807 ----
    else
      file = savestring (file);
  
+ #if defined (USE_VMS)
+   if (absolute_pathname (file))
+ #else
    if ((*file == '/') && absolute_pathname (file))
+ #endif
      return (file);
  
    disposer = file;
***************
*** 781,787 ****
--- 809,819 ----
    {
      char *current_dir = xmalloc (2 + MAXPATHLEN + strlen (file));
      int dlen;
+ #if defined (USE_VMS)
+     if (vmsutil_getwd (current_dir) == 0)
+ #else
      if (getwd (current_dir) == 0)
+ #endif
        {
  	report_error (current_dir);
  	free (current_dir);
***************
*** 1093,1099 ****
--- 1125,1135 ----
    extern char *getcwd ();
    char *result;
  
+ #if defined (USE_VMS)
+   result = vmsutil_getcwd (string, MAXPATHLEN);
+ #else
    result = getcwd (string, MAXPATHLEN);
+ #endif
    if (result == NULL)
      strcpy (string, "getwd: cannot access parent directories");
    return (result);
***************
*** 1165,1171 ****
  
  #endif /* NO_READ_RESTART_ON_SIGNAL */
  
! #if defined (USG) || defined (AIX) || (defined (_POSIX_VERSION) && defined (Ultrix))
  /* USG and strict POSIX systems do not have killpg ().  But we use it in
     jobs.c, nojobs.c and some of the builtins.  This can also be redefined
     as a macro if necessary. */
--- 1201,1207 ----
  
  #endif /* NO_READ_RESTART_ON_SIGNAL */
  
! #if defined (USG) || defined (AIX) || (defined (_POSIX_VERSION) && defined (Ultrix)) || defined (VMS)
  /* USG and strict POSIX systems do not have killpg ().  But we use it in
     jobs.c, nojobs.c and some of the builtins.  This can also be redefined
     as a macro if necessary. */
***************
*** 1271,1273 ****
--- 1307,1313 ----
    return (oact.sa_handler);
  }
  #endif /* _POSIX_VERSION */
+ 
+ #if defined (USE_VMS)
+ #include "vmsutil.c"
+ #endif
diff -r -c bash-1_14_7/general.h bash1147/general.h
*** bash-1_14_7/general.h	Wed Mar 10 09:43:47 1999
--- bash1147/general.h	Fri Mar 19 17:49:02 1999
***************
*** 220,227 ****
--- 220,229 ----
  extern void tilde_initialize __P((void));
  
  #if !defined (strerror)
+ #ifndef VMS
  extern char *strerror __P((int));
  #endif
+ #endif
  
  #if defined (RLIMTYPE)
  extern RLIMTYPE string_to_rlimtype __P((char *));
***************
*** 243,247 ****
--- 245,253 ----
  #if defined (USG) && !defined (HAVE_GETHOSTNAME)
  extern int gethostname __P((char *, int));
  #endif /* USG && !HAVE_GETHOSTNAME */
+ 
+ #if defined (USE_VMS)
+ #include "vmsutil.h"
+ #endif
  
  #endif	/* _GENERAL_H */
diff -r -c bash-1_14_7/input.c bash1147/input.c
*** bash-1_14_7/input.c	Wed Mar 10 09:43:47 1999
--- bash1147/input.c	Fri Mar 19 17:36:15 1999
***************
*** 137,150 ****
--- 137,162 ----
  	 might be able to avoid this by copying the buffered stream verbatim
  	 to the new file descriptor. */
        if (buffers[fd])
+ #if defined (USE_VMS)
+ 	sync_buffered_stream_crlf (fd);
+ #else
  	sync_buffered_stream (fd);
+ #endif
  
        /* Now take care of duplicating the file descriptor that bash is
  	 using for input, so we can reinitialize it later. */
+ #if defined (USE_VMS)
+       nfd = vmsfcntl (fd, F_DUPFD, 10);
+ #else
        nfd = fcntl (fd, F_DUPFD, 10);
+ #endif
        if (nfd == -1)
  	{
+ #if defined (USE_VMS)
+ 	  if (vmsfcntl (fd, F_GETFD, 0) == 0)
+ #else
  	  if (fcntl (fd, F_GETFD, 0) == 0)
+ #endif
  	    report_error
  	      ("cannot allocate new file descriptor for bash input from fd %d: %s",
  		fd, strerror (errno));
***************
*** 306,320 ****
--- 318,350 ----
  }
  
  /* Read a buffer full of characters from BP, a buffered stream. */
+ #if defined (USE_VMS) /* ??? */
+ #define B_USECR 0x100
+ #endif
  static int
  b_fill_buffer (bp)
       BUFFERED_STREAM *bp;
  {
+ #if defined (USE_VMS)
+   long plpos = lseek (bp->b_fd, 0, SEEK_CUR);
+   long nlpos;
+ #endif
+ 
    do
      {
        bp->b_used = read (bp->b_fd, bp->b_buffer, bp->b_size);
      }
    while (bp->b_used < 0 && errno == EINTR);
+ 
+ #if defined (USE_VMS)
+   nlpos = lseek (bp->b_fd, 0, SEEK_CUR);
+   if ((plpos >= 0) && (nlpos >= 0) && (bp->b_used >= 0))
+     {
+       if ((plpos + bp->b_used) != nlpos)
+ 	bp->b_flag |= B_USECR;
+     }
+ #endif
+ 
    if (bp->b_used <= 0)
      {
        bp->b_buffer[0] = 0;
***************
*** 365,370 ****
--- 395,435 ----
    bp->b_used = bp->b_inputp = 0;
    return (0);
  }
+ 
+ #if defined (USE_VMS)
+ int
+ sync_buffered_stream_crlf (bfd)
+      int bfd;
+ {
+   BUFFERED_STREAM *bp;
+   int chars_left;
+ 
+   bp = buffers[bfd];
+   if (!bp)
+     return (-1);
+   chars_left = bp->b_used - bp->b_inputp;
+ 
+   if (chars_left)
+     {
+       lseek (bp->b_fd, -chars_left, SEEK_CUR);
+       if (bp->b_flag & B_USECR)
+ 	{
+ 	  int i = bp->b_inputp;
+ 	  int crlf = 0;
+ 	  char *p = bp->b_buffer + bp->b_inputp;
+ 
+ 	  while (i++ < bp->b_used)
+ 	    if (*p++ == '\n')
+ 	      crlf++;
+ 
+ 	  lseek (bp->b_fd, -crlf, SEEK_CUR);
+ 	}
+     }
+ 
+   bp->b_used = bp->b_inputp = 0;
+   return (0);
+ }
+ #endif
  
  int
  buffered_getchar ()
diff -r -c bash-1_14_7/jobs.c bash1147/jobs.c
*** bash-1_14_7/jobs.c	Wed Mar 10 09:43:47 1999
--- bash1147/jobs.c	Fri Mar 19 17:36:15 1999
***************
*** 48,54 ****
--- 48,56 ----
  #include <sys/file.h>
  #include "filecntl.h"
  #include <sys/ioctl.h>
+ #if !defined (VMS)
  #include <sys/param.h>
+ #endif
  
  #if defined (BUFFERED_INPUT)
  #  include "input.h"
***************
*** 74,79 ****
--- 76,85 ----
  #  endif /* USG | hpux | Xenix | sgi */
  #endif /* !_POSIX_VERSION */
  
+ #if defined (VMS)
+ #undef NEW_TTY_DRIVER
+ #endif
+ 
  /* Include the right header file for the specific type of terminal
     handler installed on this system. */
  #if defined (NEW_TTY_DRIVER)
***************
*** 200,205 ****
--- 206,218 ----
     commands. */
  static int freeze_jobs_list;
  
+ #if defined (VMS)
+ #  define getpgid(p) 0
+ #  define getpgrp(p) 0
+ #  define tcgetpgrp(p) 0
+ #  define setpgid(t,p) 0
+ #  define tcsetpgrp(t,p) 0
+ #else
  #if !defined (_POSIX_VERSION)
  
  /* These are definitions to map POSIX 1003.1 functions onto existing BSD
***************
*** 248,253 ****
--- 261,267 ----
      *oldset = old;
  }
  #endif /* !_POSIX_VERSION */
+ #endif
  
  /* Return the working directory for the current process.  Unlike
     job_working_directory, this does not call malloc (), nor do any
***************
*** 991,996 ****
--- 1005,1013 ----
        (!async_p || default_buffered_input > 0))
      sync_buffered_stream (default_buffered_input);
  #endif /* BUFFERED_INPUT */
+ #if defined (VMS)
+ #define fork vfork
+ #endif
  
    /* Create the child, handle severe errors. */
    if ((pid = fork ()) < 0)
***************
*** 1158,1163 ****
--- 1175,1184 ----
  static struct termios shell_tty_info;
  #endif /* TERMIOS_TTY_DRIVER */
  
+ #if !(defined (NEW_TTY_DRIVER) || defined (TERMIO_TTY_DRIVER) || defined (TERMIOS_TTY_DRIVER))
+ static int shell_tty_info;
+ #endif
+ 
  #if defined (NEW_TTY_DRIVER) && defined (DRAIN_OUTPUT)
  /* Since the BSD tty driver does not allow us to change the tty modes
     while simultaneously waiting for output to drain and preserving
***************
*** 1800,1805 ****
--- 1821,1830 ----
    static struct termios save_stty;
  #endif
  
+ #if !(defined (NEW_TTY_DRIVER) || defined (TERMIO_TTY_DRIVER) || defined (TERMIOS_TTY_DRIVER))
+   static int save_stty;
+ #endif
+ 
    BLOCK_CHILD (set, oset);
    already_running = (JOBSTATE (job) == JRUNNING);
  
***************
*** 2475,2480 ****
--- 2500,2509 ----
  #  endif /* TERMIOS_LDISC */
    return (0);
  #endif /* TERMIOS_TTY_DRIVER */
+ 
+ #if defined (VMS)
+   return (0);
+ #endif
  
  #if !defined (NEW_TTY_DRIVER) && !defined (TERMIO_TTY_DRIVER) && !defined (TERMIOS_TTY_DRIVER)
    return (-1);
diff -r -c bash-1_14_7/jobs.h bash1147/jobs.h
*** bash-1_14_7/jobs.h	Wed Mar 10 09:43:47 1999
--- bash1147/jobs.h	Wed Mar 10 09:44:55 1999
***************
*** 282,288 ****
  #endif /* !_POSIX_VERSION */
  
  /* System calls. */
! #if !defined (SunOS5) && !defined (USGr4_2) && !defined (__BSD_4_4__)
  extern pid_t fork (), getpid (), getpgrp ();
  #endif /* !SunOS5 && !USGr4_2 && !__BSD_4_4__ */
  
--- 282,288 ----
  #endif /* !_POSIX_VERSION */
  
  /* System calls. */
! #if !defined (SunOS5) && !defined (USGr4_2) && !defined (__BSD_4_4__) && !defined(VMS)
  extern pid_t fork (), getpid (), getpgrp ();
  #endif /* !SunOS5 && !USGr4_2 && !__BSD_4_4__ */
  
diff -r -c bash-1_14_7/lib/readline/complete.c bash1147/lib/readline/complete.c
*** bash-1_14_7/lib/readline/complete.c	Wed Mar 10 09:44:01 1999
--- bash1147/lib/readline/complete.c	Fri Mar 19 15:37:37 1999
***************
*** 963,970 ****
  {
    struct stat finfo;
    int character, r;
! 
! #if defined (S_ISLNK)
    r = lstat (filename, &finfo);
  #else
    r = stat (filename, &finfo);
--- 963,969 ----
  {
    struct stat finfo;
    int character, r;
! #if defined (S_ISLNK) && !defined (VMS)
    r = lstat (filename, &finfo);
  #else
    r = stat (filename, &finfo);
***************
*** 1015,1021 ****
       int state;
       char *text;
  {
! #if defined (__GO32__)
    return (char *)NULL;
  #else /* !__GO32__ */
    static char *username = (char *)NULL;
--- 1014,1020 ----
       int state;
       char *text;
  {
! #if defined (__GO32__) || defined (USE_VMS)
    return (char *)NULL;
  #else /* !__GO32__ */
    static char *username = (char *)NULL;
diff -r -c bash-1_14_7/lib/readline/display.c bash1147/lib/readline/display.c
*** bash-1_14_7/lib/readline/display.c	Wed Mar 10 09:44:01 1999
--- bash1147/lib/readline/display.c	Wed Mar 10 09:45:18 1999
***************
*** 62,68 ****
--- 62,72 ----
  extern int terminal_can_insert, term_xn;
  
  extern void _rl_output_some_chars ();
+ #ifdef _BSD44_CURSES
+ extern void _rl_output_character_function ();
+ #else
  extern int _rl_output_character_function ();
+ #endif
  
  extern int _rl_output_meta_chars;
  extern int _rl_horizontal_scroll_mode;
***************
*** 1132,1138 ****
    /* If IC is defined, then we do not have to "enter" insert mode. */
    if (term_IC)
      {
!       char *tgoto (), *buffer;
        buffer = tgoto (term_IC, 0, count);
        tputs (buffer, 1, _rl_output_character_function);
        _rl_output_some_chars (string, count);
--- 1136,1145 ----
    /* If IC is defined, then we do not have to "enter" insert mode. */
    if (term_IC)
      {
! #ifndef VMS
!       char *tgoto ();
! #endif
!       char *buffer;
        buffer = tgoto (term_IC, 0, count);
        tputs (buffer, 1, _rl_output_character_function);
        _rl_output_some_chars (string, count);
***************
*** 1186,1192 ****
  
    if (term_DC && *term_DC)
      {
!       char *tgoto (), *buffer;
        buffer = tgoto (term_DC, count, count);
        tputs (buffer, count, _rl_output_character_function);
      }
--- 1193,1202 ----
  
    if (term_DC && *term_DC)
      {
! #ifndef VMS
!       char *tgoto ();
! #endif
!       char *buffer;
        buffer = tgoto (term_DC, count, count);
        tputs (buffer, count, _rl_output_character_function);
      }
diff -r -c bash-1_14_7/lib/readline/history.c bash1147/lib/readline/history.c
*** bash-1_14_7/lib/readline/history.c	Wed Mar 10 09:44:01 1999
--- bash1147/lib/readline/history.c	Fri Mar 19 15:23:18 1999
***************
*** 25,30 ****
--- 25,34 ----
     you can call.  I think I have done that. */
  #define READLINE_LIBRARY
  
+ #ifdef HAVE_CONFIG_H
+ #include "config.h"
+ #endif
+ 
  #include <stdio.h>
  #include <sys/types.h>
  #include <sys/file.h>
